'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _cfStyleContainer = require('cf-style-container');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const styles = ({ theme }) => ({
  zIndex: theme.zIndex,
  width: theme.width,
  height: theme.height,
  margin: theme.margin,
  padding: theme.padding,
  borderBottom: theme.borderBottom,
  borderTop: theme.borderTop,
  borderLeft: theme.borderLeft,
  borderRight: theme.borderRight,
  borderRadius: theme.borderRadius,
  flex: theme.flex,

  verticalAlign: theme.verticalAlign,
  fontFamily: theme.fontFamily,
  fontSize: theme.fontSize,

  background: theme.background,
  color: theme.color,
  outline: theme.outline,

  transition: theme.transition,
  textIndent: theme.textIndent,

  '&:hover': {
    borderColor: theme['&:hover'].borderColor
  },

  '&:focus': {
    borderColor: theme['&:hover'].borderColor,
    outline: theme['&:hover'].outline
  }
});

class Input extends _react2.default.Component {
  render() {
    const _props = this.props,
          { inputRef } = _props,
          restProps = _objectWithoutProperties(_props, ['inputRef']);
    return _react2.default.createElement('input', _extends({}, restProps, { ref: inputRef }));
  }
}

Input.propTypes = {
  type: _propTypes2.default.oneOf(['text', 'email', 'number', 'password', 'search', 'color']),
  name: _propTypes2.default.string.isRequired,
  value: _propTypes2.default.string,
  defaultValue: _propTypes2.default.string,
  onChange: _propTypes2.default.func.isRequired,
  onKeyDown: _propTypes2.default.func,
  inputRef: _propTypes2.default.func,
  onBlur: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  placeholder: _propTypes2.default.string,
  autoComplete: _propTypes2.default.string,
  className: _propTypes2.default.string,
  disabled: _propTypes2.default.bool
};

Input.defaultProps = {
  type: 'text'
};

exports.default = (0, _cfStyleContainer.createComponent)(styles, Input);